﻿// This work contains valuable confidential and proprietary information. 
// Disclosure, use, or reproduction without the written authorization of 
// Vitaliy Leschenko is strictly prohibited. This unpublished work 
// is Copyright (c) and protected by the laws. 
// 
// If publication of the work should occur, the following notice shall apply: 
// Copyright (c) 2009 Vitaliy Leschenko. All rights reserved.
//
// $Id: App.xaml.cs 518 2009-09-07 03:34:33Z v.leschenko $ 
//
using System;
using System.Diagnostics;
using System.Windows;
using System.Windows.Browser;

namespace Mercury.Web.Silverlight.Tags
{
    public partial class App : Application
    {
        public string TagUrl { get; private set; }
        public string ServiceUrl { get; private set; }

        public App()
        {
            Startup += OnApplicationStartup;
            Exit += OnApplicationExit;
            UnhandledException += OnApplicationUnhandledException;

            InitializeComponent();
        }

        private void OnApplicationStartup(object sender, StartupEventArgs e)
        {
            TagUrl = e.InitParams["url"] ?? string.Empty;
            ServiceUrl = e.InitParams["service"] ?? string.Empty;

            RootVisual = new MainPage();
        }

        private void OnApplicationExit(object sender, EventArgs e) {}

        private void OnApplicationUnhandledException(object sender, ApplicationUnhandledExceptionEventArgs e)
        {
            // If the app is running outside of the debugger then report the exception using
            // the browser's exception mechanism. On IE this will display it a yellow alert 
            // icon in the status bar and Firefox will display a script error.
            if (!Debugger.IsAttached)
            {
                // NOTE: This will allow the application to continue running after an exception has been thrown
                // but not handled. 
                // For production applications this error handling should be replaced with something that will 
                // report the error to the website and stop the application.
                e.Handled = true;
                Deployment.Current.Dispatcher.BeginInvoke(() => ReportErrorToDOM(e));
            }
        }

        private void ReportErrorToDOM(ApplicationUnhandledExceptionEventArgs e)
        {
            try
            {
                var errorMsg = e.ExceptionObject.Message + e.ExceptionObject.StackTrace;
                errorMsg = errorMsg.Replace('"', '\'').Replace("\r\n", @"\n");

                HtmlPage.Window.Eval("throw new Error(\"Unhandled Error in Silverlight Application " + errorMsg + "\");");
            }
            catch {}
        }
    }
}