﻿// This work contains valuable confidential and proprietary information. 
// Disclosure, use, or reproduction without the written authorization of 
// Vitaliy Leschenko is strictly prohibited. This unpublished work 
// is Copyright (c) and protected by the laws. 
// 
// If publication of the work should occur, the following notice shall apply: 
// Copyright (c) 2009 Vitaliy Leschenko. All rights reserved.
//
// $Id: UrlHelper.cs 518 2009-09-07 03:34:33Z v.leschenko $ 
//

using System;
using System.Windows;

namespace Mercury.Web.Silverlight.Tags
{
    public static class UrlHelper
    {
        private const string HostUrl = "{0}://{1}:{2}";

        private static string GetHostUrl()
        {
            var uri = Application.Current.Host.Source;
            return string.Format(HostUrl, uri.Scheme, uri.Host, uri.Port);
        }

        public static Uri GetUri(string path)
        {
            var host = GetHostUrl();
            return new Uri(host + path);
        }

        public static Uri GetTagUri(string tag)
        {
            var path = string.Format(((App) Application.Current).TagUrl, tag);
            return GetUri(path);
        }
    }
}
